import command

class DebugCmd(command.Command):
	name = "debug-cmd"
	def call(self, con):
		arg = self.getarg()
		if (arg == 0):
			log.log('qwerty')
		elif (arg == -99):
			log.clear()
		elif (arg == -100):
			self.nonexistentmethod()
		elif (arg == 10):
			log.log('X')
		elif (arg >= 1 and arg <= 9):
			log.log(' ' + (str(arg) * arg))
		elif (arg < 0):
			log.log('-\n' * (-arg))
			
class DebugCmdStatus(command.Command):
	name = "debug-cmd-status"
	def call(self, con):
		raise command.StatusWarning('Hello.')

class DebugCmdInputKey(command.Command):
	name = "debug-cmd-input-key"
	def call(self, con):
		key = inputkey.input_ascii(self)
		raise command.StatusWarning('DebugCmdInputKey: '+command.keyname(key))

class DebugCmdInputChoice(command.Command):
	name = "debug-cmd-input-choice"
	def call(self, con):
		res = inputkey.input_choice(self, 'DebugCmdInputChoice: ',
			{'h':'hello', 'g':'goodbye'})
		log.log('DebugCmdInputChoice: '+res+'\n')

class DebugCmdInputFile(command.Command):
	name = "debug-cmd-input-file"
	def call(self, con):
		st = inputstring.input_filename(self, 'File', self.name)
		log.log('DebugCmdInputFile: "'+st+'"\n')

class DebugCmdInputString(command.Command):
	name = "debug-cmd-input-string"
	def call(self, con):
		st = inputstring.input_string(self, 'String', self.name)
		log.log('DebugCmdInputString: "'+st+'"\n')

class DebugCmdMinibuffer(command.Command):
	name = "debug-cmd-minibuffer"
	savedfocus = 0
	def call(self, con):
		arg = self.getarg()
		if (arg):
			minibuf.activate('Command: ')
			DebugCmdMinibuffer.savedfocus = window.focuswin
			window.changefocus(-1)
		else:
			minibuf.deactivate()
			window.changefocus(DebugCmdMinibuffer.savedfocus)

command.register([
	DebugCmd,
	DebugCmdStatus, DebugCmdInputKey, DebugCmdInputString, DebugCmdInputChoice,
	DebugCmdInputFile,
	DebugCmdMinibuffer 
])

command.bind(DebugCmdStatus, 'H')
command.bind(DebugCmdInputKey, 'Q')
command.bind(DebugCmdInputString, 'X')
command.bind(DebugCmdInputChoice, 'C')
command.bind(DebugCmdInputFile, 'F')
command.bind("noop", 'ESC a') ###

command.bind(DebugCmdMinibuffer, 'M y', 1)
command.bind(DebugCmdMinibuffer, 'M n', 0)


command.bind(DebugCmd, 'ESC ^M', -9)
command.bind(DebugCmd, '^M', -1)
command.bind(DebugCmd, '^C', -99)
command.bind(DebugCmd, '^@', -100)
command.bind(DebugCmd, '0', 0)
command.bind(DebugCmd, 'ESC 0', 10)
command.bind(DebugCmd, '1', 1)
command.bind(DebugCmd, '2', 2)
command.bind(DebugCmd, '3', 3)
command.bind(DebugCmd, '4', 4)
command.bind(DebugCmd, '5', 5)
command.bind(DebugCmd, '6', 6)
command.bind(DebugCmd, '7', 7)
command.bind(DebugCmd, '8', 8)
command.bind(DebugCmd, '9', 9)

# late imports
import log
import inputkey
import inputstring
import minibuf
import completion

