import buffer

class TextBuffer(buffer.Buffer):
	classname = 'text'

	def __init__(self, bufname, initbody=''):
		buffer.Buffer.__init__(self, bufname)
		self.body = initbody
	
	def getviewclass(self):
		return textwindow.TextWindow

	def getcommandcontexts(self):
		return [TextBuffer] + buffer.Buffer.getcommandcontexts(self)

	def append(self, st):
		if (st == ''):
			return
		self.changed()
		self.body = self.body + st
		self.watch.signal(watcher.SIG_DATA)

	def clear(self):
		if (self.body == ''):
			return
		self.changed()
		self.body = ''
		self.watch.signal(watcher.SIG_DATA)

	def serialize(self, fl):
		fl.write(self.body)

buffer.registerclass(TextBuffer)

def getbyname(nam):
	return buffer.getbyname(nam, TextBuffer)

import watcher
import textwindow
import execute

execute.registercontext(TextBuffer, 'textbuffer')

